from datetime import datetime,tzinfo,timedelta

def readFile(filename):
	with open(filename) as f:
		return f.read()

class FixedOffset(tzinfo):
	def __init__(self,name,hours,minutes):
		self.__offset = timedelta(hours=hours,minutes=minutes)
		self.__name = name
	def utcoffset(self,d):
		return self.__offset
	def tzname(self):
		return self.__name
	def dst(self,d):
		return timedelta(0)

class CommonTimezones:
	UTC = FixedOffset("UTC",0,0)
	EST = FixedOffset("EST",-5,0)
	EDT = FixedOffset("EDT",-4,0)

def now_tz(tz="UTC"):
	if hasattr(CommonTimezones,tz):
		return datetime.now(tz=getattr(CommonTimezones,tz))
