import plugin, dictdata, hashlib

sha256 = lambda s: hashlib.sha256(s.encode("utf-8")).hexdigest()

fixed_opinions = dictdata.DictData("fixed_opinions.json")

BOLD = b"\x02".decode("ascii")
RESET = b"\x0f".decode("ascii")
OPINIONS = ["suck","neat","cool","bad"]

def suckify(s):
	return BOLD+" ".join(list(s))+RESET

def chunkify(o,s):
	ret = []
	for i in range(0,len(o),s):
		ret.append(o[i:i+s])
	return ret

def get_opinion(s):
	if s in fixed_opinions: return fixed_opinions[s]
	hash = chunkify(sha256(s),2)
	h = int(hash[len(s)%len(hash)],16)
	return OPINIONS[h%len(OPINIONS)]

@plugin.command("opinion","<opinionated item>")
def opinion(bot,channel,nick,*args):
	if not args: return
	bot.say(channel,"{}: {} {}".format(nick," ".join(args),suckify(get_opinion(" ".join(args)))))
