import plugin,dictdata,json,os

d = dictdata.DictData("urls.json")

def collections(): return sorted(list(d.value.keys()))

def getFilename():
	i = 0
	while os.path.exists("/home/khuxkm/public_html/public/urls-{:05d}.txt".format(i)):
		i+=1
	return "/home/khuxkm/public_html/public/urls-{:05d}.txt".format(i)

def writeCollection(c,fn):
	with open(fn,"w") as f:
		f.write("\n".join(d[c])+"\n")

@plugin.group("url","<list/new/add/remove/export/expire/dump> [args]")
def url(self,channel,nick,subcmd,*args):
	d.load(d.filename)
	if subcmd not in "list new add remove export dump expire":
		return True
	return False

@url.command("list")
def url_list(self,channel,nick,subcmd,name=None):
	if name is None:
		self.say(channel,"{}: Collections: {}".format(nick,", ".join(collections())))
	elif name in collections():
		self.say(channel,"{}: URLs in this list include: {}".format(nick,", ".join(d.get(name,[])[-3:])))
	else:
		self.say(channel,"{}: No such collection {!r}".format(nick,name))

@url.command("new")
def url_new(self,channel,nick,subcmd,name):
	if name in collections():
		self.say(channel,"{}: Collection {!r} already exists".format(nick,name))
		return
	d[name]=[]
	d.save(d.filename)

@url.command("expire")
def url_expire(self,channel,nick,subcmd,name):
	if name not in collections():
		self.say(channel,"{}: Collection {!r} doesn't exist".format(nick,name))
		return
	del d.value[name]
	d.save(d.filename)

@url.command("add")
def url_add(self,channel,nick,subcmd,collection,u):
	if collection not in collections():
		self.say(channel,"{}: No collection {!r}".format(nick,collection))
		return
	d[collection].append(u)
	d.save(d.filename)

@url.command("remove")
def url_remove(self,channel,nick,subcmd,collection,u):
	if collection not in collections():
		self.say(channel,"{}: No collection {!r}".format(nick,collection))
		return
	if u not in d[collection]:
		return
	d[collection].remove(u)
	d.save(d.filename)

@url.command("dump")
def url_dump(self,channel,nick,*args):
	self.say(nick,d.serialize())

@url.command("export")
def url_export(self,channel,nick,subcmd,collection):
	if collection not in collections():
		self.say(channel,"{}: No collection {!r}".format(nick,collection))
		return
	fn = getFilename()
	out = fn.replace("/home/khuxkm/public_html","https://khuxkm.fuckup.club")
	writeCollection(collection,fn)
	self.say(channel,"{}: Collection {!r} exported to {}".format(nick,collection,out))
